Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -2769,20 +2999,20 @@
        DO  k = nzb+3, nzt-2
 
-          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
-          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
-          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
+          ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
 
           w_comp(k) = w(k,j-1,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( v(k+1,j,i)   + v(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( v(k+2,j,i)  + v(k-1,j,i)  )                 &
-              +      (           ibit26 * adv_mom_5                           &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i) + v(k,j,i)   )                   &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k+2,j,i) + v(k-1,j,i) )                   &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k+3,j,i) + v(k-2,j,i) )                   &
@@ -2790,14 +3020,14 @@
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( v(k+1,j,i)   - v(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( v(k+2,j,i)  - v(k-1,j,i)  )                 &
-              +      (           ibit26 * adv_mom_5                           &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i) - v(k,j,i)   )                   &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k+2,j,i) - v(k-1,j,i) )                    &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k+3,j,i) - v(k-2,j,i) )                   &
@@ -2809,24 +3039,24 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
-          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
-          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit26
-          k_pp  = k + 2 * ( 1 - ibit24  )
-          k_mm  = k - 2 * ibit26
+          ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit17
+          k_pp  = k + 2 * ( 1 - ibit15  )
+          k_mm  = k - 2 * ibit17
 
           w_comp(k) = w(k,j-1,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
                      ) *                                                      &
                                 ( v(k+1,j,i)   + v(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
                      ) *                                                      &
                                 ( v(k_pp,j,i)  + v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k_ppp,j,i) + v(k_mm,j,i) )                &
@@ -2834,14 +3064,14 @@
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
                      ) *                                                      &
                                 ( v(k+1,j,i)   - v(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
                      ) *                                                      &
                                 ( v(k_pp,j,i)  - v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k_ppp,j,i) - v(k_mm,j,i) )                &
@@ -2854,15 +3084,15 @@
           diss_d    = diss_t(k-1)
           
-          ibit20 = REAL( IBITS(advc_flags_1(k,j,i),20,1), KIND = wp )
-          ibit19 = REAL( IBITS(advc_flags_1(k,j,i),19,1), KIND = wp )
-          ibit18 = REAL( IBITS(advc_flags_1(k,j,i),18,1), KIND = wp )
+          ibit11 = REAL( IBITS(advc_flags_m(k,j,i),11,1), KIND = wp )
+          ibit10 = REAL( IBITS(advc_flags_m(k,j,i),10,1), KIND = wp )
+          ibit9  = REAL( IBITS(advc_flags_m(k,j,i),9,1), KIND = wp )
           
-          ibit23 = REAL( IBITS(advc_flags_1(k,j,i),23,1), KIND = wp )
-          ibit22 = REAL( IBITS(advc_flags_1(k,j,i),22,1), KIND = wp )
-          ibit21 = REAL( IBITS(advc_flags_1(k,j,i),21,1), KIND = wp )
+          ibit14 = REAL( IBITS(advc_flags_m(k,j,i),14,1), KIND = wp )
+          ibit13 = REAL( IBITS(advc_flags_m(k,j,i),13,1), KIND = wp )
+          ibit12 = REAL( IBITS(advc_flags_m(k,j,i),12,1), KIND = wp )
           
-          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
-          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
-          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
+          ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
 !
 !--       Calculate the divergence of the velocity field. A respective
@@ -2870,27 +3100,27 @@
 !--       by a not sufficient reduction of divergences near topography.
           div = ( ( ( u_comp(k)     + gu )                                    &
-                                       * ( ibit18 + ibit19 + ibit20 )         &
+                                       * ( ibit9 + ibit10 + ibit11 )          &
                   - ( u(k,j-1,i) + u(k,j,i) )                                 &
                                        * (                                    &
-                        REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )  &
+                        REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )  &
                                          )                                    &
                   ) * ddx                                                     &
                +  ( v_comp(k)                                                 &
-                                       * ( ibit21 + ibit22 + ibit23 )         &
+                                       * ( ibit12 + ibit13 + ibit14 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
                                        * (                                    &
-                        REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )  &
+                        REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )  &
                                          )                                    &
                   ) * ddy                                                     &
-               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit24 + ibit25 + ibit26 )&
+               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )&
                 -   w_comp(k-1) * rho_air_zw(k-1)                             &
                                        * (                                    &
-                        REAL( IBITS(advc_flags_1(k-1,j,i),24,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),25,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),26,1), KIND = wp )  &
+                        REAL( IBITS(advc_flags_m(k-1,j,i),15,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),16,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),17,1), KIND = wp )  &
                                          )                                    &
                    ) * drho_air(k) * ddzw(k)                                  &
@@ -3011,13 +3241,13 @@
        INTEGER(iwp) ::  tn        !< number of OpenMP thread
        
-       REAL(wp)    ::  ibit27  !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit28  !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit29  !< flag indicating 5th-order scheme along x-direction
-       REAL(wp)    ::  ibit30  !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit31  !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit32  !< flag indicating 5th-order scheme along y-direction
-       REAL(wp)    ::  ibit33  !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit34  !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit35  !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  ibit18  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit19  !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit20  !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit21  !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit22  !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit23  !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit24  !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit25  !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit26  !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d  !< discretized artificial dissipation at top of the grid box
        REAL(wp)    ::  div     !< divergence on w-grid
@@ -3056,20 +3286,20 @@
 
           DO  k = nzb+1, nzb_max_l
-             ibit32 = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
-             ibit31 = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
-             ibit30 = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
+             ibit23 = REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )
+             ibit22 = REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )
+             ibit21 = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
 
              v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
              flux_s_w(k,tn) = v_comp(k) * (                                   &
-                            ( 37.0_wp * ibit32 * adv_mom_5                    &
-                         +     7.0_wp * ibit31 * adv_mom_3                    &
-                         +              ibit30 * adv_mom_1                    &
+                            ( 37.0_wp * ibit23 * adv_mom_5                    &
+                         +     7.0_wp * ibit22 * adv_mom_3                    &
+                         +              ibit21 * adv_mom_1                    &
                             ) *                                               &
                                         ( w(k,j,i)   + w(k,j-1,i) )           &
-                     -      (  8.0_wp * ibit32 * adv_mom_5                    &
-                         +              ibit31 * adv_mom_3                    &
+                     -      (  8.0_wp * ibit23 * adv_mom_5                    &
+                         +              ibit22 * adv_mom_3                    &
                             ) *                                               &
                                         ( w(k,j+1,i) + w(k,j-2,i) )           &
-                     +      (           ibit32 * adv_mom_5                    &
+                     +      (           ibit23 * adv_mom_5                    &
                             ) *                                               &
                                         ( w(k,j+2,i) + w(k,j-3,i) )           &
@@ -3077,14 +3307,14 @@
 
              diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                          &
-                            ( 10.0_wp * ibit32 * adv_mom_5                    &
-                         +     3.0_wp * ibit31 * adv_mom_3                    &
-                         +              ibit30 * adv_mom_1                    &
+                            ( 10.0_wp * ibit23 * adv_mom_5                    &
+                         +     3.0_wp * ibit22 * adv_mom_3                    &
+                         +              ibit21 * adv_mom_1                    &
                             ) *                                               &
                                         ( w(k,j,i)   - w(k,j-1,i) )           &
-                     -      (  5.0_wp * ibit32 * adv_mom_5                    &
-                         +              ibit31 * adv_mom_3                    &
+                     -      (  5.0_wp * ibit23 * adv_mom_5                    &
+                         +              ibit22 * adv_mom_3                    &
                             ) *                                               &
                                         ( w(k,j+1,i) - w(k,j-2,i) )           &
-                     +      (           ibit32 * adv_mom_5                    &
+                     +      (           ibit23 * adv_mom_5                    &
                             ) *                                               &
                                         ( w(k,j+2,i) - w(k,j-3,i) )           &
@@ -3097,9 +3327,9 @@
              v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
              flux_s_w(k,tn) = v_comp(k) * (                                   &
-                           37.0_wp * ( w(k,j,i) + w(k,j-1,i)   )              &
-                         -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )              &
+                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )              &
+                         -  8.0_wp * ( w(k,j+1,i) + w(k,j-2,i) )              &
                          +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
              diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                          &
-                           10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )              &
+                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )              &
                          -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )              &
                          +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
@@ -3114,20 +3344,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit29 = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
-             ibit28 = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
-             ibit27 = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
+             ibit20 = REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )
+             ibit19 = REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )
+             ibit18 = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
 
              u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
              flux_l_w(k,j,tn) = u_comp(k) * (                                 &
-                             ( 37.0_wp * ibit29 * adv_mom_5                   &
-                          +     7.0_wp * ibit28 * adv_mom_3                   &
-                          +              ibit27 * adv_mom_1                   &
+                             ( 37.0_wp * ibit20 * adv_mom_5                   &
+                          +     7.0_wp * ibit19 * adv_mom_3                   &
+                          +              ibit18 * adv_mom_1                   &
                              ) *                                              &
                                         ( w(k,j,i)   + w(k,j,i-1) )           &
-                      -      (  8.0_wp * ibit29 * adv_mom_5                   &
-                          +              ibit28 * adv_mom_3                   &
+                      -      (  8.0_wp * ibit20 * adv_mom_5                   &
+                          +              ibit19 * adv_mom_3                   &
                              ) *                                              &
                                         ( w(k,j,i+1) + w(k,j,i-2) )           &
-                      +      (           ibit29 * adv_mom_5                   &
+                      +      (           ibit20 * adv_mom_5                   &
                              ) *                                              &
                                         ( w(k,j,i+2) + w(k,j,i-3) )           &
@@ -3135,14 +3365,14 @@
 
                diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                      &
-                             ( 10.0_wp * ibit29 * adv_mom_5                   &
-                          +     3.0_wp * ibit28 * adv_mom_3                   &
-                          +              ibit27 * adv_mom_1                   &
+                             ( 10.0_wp * ibit20 * adv_mom_5                   &
+                          +     3.0_wp * ibit19 * adv_mom_3                   &
+                          +              ibit18 * adv_mom_1                   &
                              ) *                                              &
                                         ( w(k,j,i)   - w(k,j,i-1) )           &
-                      -      (  5.0_wp * ibit29 * adv_mom_5                   &
-                          +              ibit28 * adv_mom_3                   &
+                      -      (  5.0_wp * ibit20 * adv_mom_5                   &
+                          +              ibit19 * adv_mom_3                   &
                              ) *                                              &
                                         ( w(k,j,i+1) - w(k,j,i-2) )           &
-                      +      (           ibit29 * adv_mom_5                   &
+                      +      (           ibit20 * adv_mom_5                   &
                              ) *                                              &
                                         ( w(k,j,i+2) - w(k,j,i-3) )           &
@@ -3155,9 +3385,9 @@
              u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
              flux_l_w(k,j,tn) = u_comp(k) * (                                 &
-                            37.0_wp * ( w(k,j,i) + w(k,j,i-1)   )             &
+                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1) )             &
                           -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )             &
                           +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
              diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                        &
-                            10.0_wp * ( w(k,j,i) - w(k,j,i-1)   )             &
+                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1) )             &
                           -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )             &
                           +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5 
@@ -3171,20 +3401,20 @@
        DO  k = nzb+1, nzb_max_l
 
-          ibit29 = REAL( IBITS(advc_flags_1(k,j,i),29,1), KIND = wp )
-          ibit28 = REAL( IBITS(advc_flags_1(k,j,i),28,1), KIND = wp )
-          ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
+          ibit20 = REAL( IBITS(advc_flags_m(k,j,i),20,1), KIND = wp )
+          ibit19 = REAL( IBITS(advc_flags_m(k,j,i),19,1), KIND = wp )
+          ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
 
           u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
           flux_r(k) = u_comp(k) * (                                           &
-                     ( 37.0_wp * ibit29 * adv_mom_5                           &
-                  +     7.0_wp * ibit28 * adv_mom_3                           &
-                  +              ibit27 * adv_mom_1                           &
+                     ( 37.0_wp * ibit20 * adv_mom_5                           &
+                  +     7.0_wp * ibit19 * adv_mom_3                           &
+                  +              ibit18 * adv_mom_1                           &
                      ) *                                                      &
                                     ( w(k,j,i+1) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit29 * adv_mom_5                           &
-                  +              ibit28 * adv_mom_3                           &
+              -      (  8.0_wp * ibit20 * adv_mom_5                           &
+                  +              ibit19 * adv_mom_3                           &
                      ) *                                                      &
                                     ( w(k,j,i+2) + w(k,j,i-1) )               &
-              +      (           ibit29 * adv_mom_5                           &
+              +      (           ibit20 * adv_mom_5                           &
                      ) *                                                      &
                                     ( w(k,j,i+3) + w(k,j,i-2) )               &
@@ -3192,34 +3422,34 @@
 
           diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit29 * adv_mom_5                           &
-                  +     3.0_wp * ibit28 * adv_mom_3                           &
-                  +              ibit27 * adv_mom_1                           &
+                     ( 10.0_wp * ibit20 * adv_mom_5                           &
+                  +     3.0_wp * ibit19 * adv_mom_3                           &
+                  +              ibit18 * adv_mom_1                           &
                      ) *                                                      &
                                     ( w(k,j,i+1) - w(k,j,i)   )               &
-              -      (  5.0_wp * ibit29 * adv_mom_5                           &
-                  +              ibit28 * adv_mom_3                           &
+              -      (  5.0_wp * ibit20 * adv_mom_5                           &
+                  +              ibit19 * adv_mom_3                           &
                      ) *                                                      &
                                     ( w(k,j,i+2) - w(k,j,i-1) )               &
-              +      (           ibit29 * adv_mom_5                           &
+              +      (           ibit20 * adv_mom_5                           &
                      ) *                                                      &
                                     ( w(k,j,i+3) - w(k,j,i-2) )               &
                                            )
 
-          ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
-          ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
-          ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
+          ibit23 = REAL( IBITS(advc_flags_m(k,j,i),23,1), KIND = wp )
+          ibit22 = REAL( IBITS(advc_flags_m(k,j,i),22,1), KIND = wp )
+          ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
 
           v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
           flux_n(k) = v_comp(k) * (                                           &
-                     ( 37.0_wp * ibit32 * adv_mom_5                           &
-                  +     7.0_wp * ibit31 * adv_mom_3                           &
-                  +              ibit30 * adv_mom_1                           &
+                     ( 37.0_wp * ibit23 * adv_mom_5                           &
+                  +     7.0_wp * ibit22 * adv_mom_3                           &
+                  +              ibit21 * adv_mom_1                           &
                      ) *                                                      &
                                     ( w(k,j+1,i) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit32 * adv_mom_5                           &
-                  +              ibit31 * adv_mom_3                           &
+              -      (  8.0_wp * ibit23 * adv_mom_5                           &
+                  +              ibit22 * adv_mom_3                           &
                      ) *                                                      &
                                     ( w(k,j+2,i) + w(k,j-1,i) )               &
-              +      (           ibit32 * adv_mom_5                           &
+              +      (           ibit23 * adv_mom_5                           &
                      ) *                                                      &
                                     ( w(k,j+3,i) + w(k,j-2,i) )               &
@@ -3227,16 +3457,16 @@
 
           diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit32 * adv_mom_5                           &
-                  +     3.0_wp * ibit31 * adv_mom_3                           &
-                  +              ibit30 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j+1,i) - w(k,j,i)  )                &
-              -      (  5.0_wp * ibit32 * adv_mom_5                           &
-                  +              ibit31 * adv_mom_3                           &
-                     ) *                                                      &
-                                   ( w(k,j+2,i) - w(k,j-1,i) )                &
-              +      (           ibit32 * adv_mom_5                           &
-                     ) *                                                      &
-                                   ( w(k,j+3,i) - w(k,j-2,i) )                &
+                     ( 10.0_wp * ibit23 * adv_mom_5                           &
+                  +     3.0_wp * ibit22 * adv_mom_3                           &
+                  +              ibit21 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( w(k,j+1,i) - w(k,j,i)   )               &
+              -      (  5.0_wp * ibit23 * adv_mom_5                           &
+                  +              ibit22 * adv_mom_3                           &
+                     ) *                                                      &
+                                   ( w(k,j+2,i)  - w(k,j-1,i) )               &
+              +      (           ibit23 * adv_mom_5                           &
+                     ) *                                                      &
+                                   ( w(k,j+3,i)  - w(k,j-2,i) )               &
                                            )
        ENDDO
